/* Problem URL: https://codeforces.com/problemset/problem/1975/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n, a, b;
    cin >> n >> a >> b;
    a--, b--;

    vvi graph(n);
    rep(i, n - 1) {
        int u, v;
        cin >> u >> v;
        u--, v--;
        graph[u].push_back(v);
        graph[v].push_back(u);
    }

    auto bfs = [&](vi &dis, int a) {
        queue<int> q;
        dis[a] = 0;
        q.push(a);

        while (!q.empty()) {
            int i = q.front();
            q.pop();

            repv(j, graph[i]) {
                if (dis[j] > dis[i] + 1) {
                    dis[j] = dis[i] + 1;
                    q.push(j);
                }
            }
        }
    };

    vi disa(n, oo);
    vi disb(n, oo);

    bfs(disa, a);
    bfs(disb, b);

    vi dp(n);
    function<int(int, int)> calc = [&](int i, int p) {
        repv(j, graph[i]) {
            if (j == p) {
                continue;
            }

            rmax(dp[i], calc(j, i) + 1);
        }

        return dp[i];
    };

    calc(0, 0);

    ll ans = OO;
    function<void(int, int)> reroot = [&](int i, int p) {
        int first = 0;
        int second = 0;
        repv(j, graph[i]) {
            if (dp[j] >= first) {
                second = first;
                first = dp[j] + 1;
                continue;
            }

            rmax(second, dp[j] + 1);
        }

        rmin(ans, max(disb[i], disa[i]) + (disa[i] > disb[i] && (disb[i] & 1) != (disa[i] & 1)) + (ll)(n - 1) * 2 - first);

        repv(j, graph[i]) {
            if (j == p) {
                continue;
            }

            if (dp[j] == first - 1) {
                dp[i] = second;
            } else {
                dp[i] = first;
            }

            reroot(j, i);
        }
    };

    reroot(0, 0);

    cout << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
